#include <stdio.h>

#define uint8_t unsigned char

uint8_t S[8],M;
uint8_t A[4],B[4],F[4];
uint8_t C[4],D[4];
uint8_t C_IN,C_OUT,C_OUT1,C_OUT2,C_OUT3;
uint8_t EQ,P,G,OVR;

#define _C(v) (((v)&1)?'1':'0')

#define wire
#define assign

void alu181() {
    assign D[0] = ~( A[0] & S[4] | ~A[0] & S[5] | B[0] & S[0] | ~B[0] & S[1] );
    assign D[1] = ~( A[1] & S[4] | ~A[1] & S[5] | B[1] & S[0] | ~B[1] & S[1] );
    assign D[2] = ~( A[2] & S[4] | ~A[2] & S[5] | B[2] & S[0] | ~B[2] & S[1] );
    assign D[3] = ~( A[3] & S[4] | ~A[3] & S[5] | B[3] & S[0] | ~B[3] & S[1] );

    assign C[0] = ~((~A[0] & S[6] | A[0] & S[7])&(~B[0] & S[2] | B[0] & S[3]));
    assign C[1] = ~((~A[1] & S[6] | A[1] & S[7])&(~B[1] & S[2] | B[1] & S[3]));
    assign C[2] = ~((~A[2] & S[6] | A[2] & S[7])&(~B[2] & S[2] | B[2] & S[3]));
    assign C[3] = ~((~A[3] & S[6] | A[3] & S[7])&(~B[3] & S[2] | B[3] & S[3]));

    wire C_OUT1 = ~( D[0] | ~C_IN & C[0]);
    wire C_OUT2 = ~( D[1] | C[1] & D[0] | ~C_IN & C[0] & C[1]);
    wire C_OUT3 = ~( D[2] | C[2] & ( D[1] | C[1] & D[0])
		     | ~C_IN & C[0] & C[1] & C[2]);

    assign P = ~( C[3] & C[2] & C[1] & C[0] );
    assign G = ~(D[3] | C[3] & ( D[2] | C[2] & ( D[1] | C[1] & D[0])));
    assign C_OUT = ~(~G | ~C_IN & C[0] & C[1] & C[2] & C[3]);

    assign F[0] = ~( ~M & ~C_IN ) ^ D[0] ^ C[0];
    assign F[1] = ~( ~M & ~C_OUT1 ) ^ D[1] ^ C[1];
    assign F[2] = ~( ~M & ~C_OUT2 ) ^ D[2] ^ C[2];
    assign F[3] = ~( ~M & ~C_OUT3 ) ^ D[3] ^ C[3];

    assign OVR = ~M & (C_OUT3 ^ C_OUT);
    assign EQ = F[0] & F[1] & F[2] & F[3];

	printf("M %c ", _C(M) );
	printf("S = %c%c%c%c ", _C(S[3]), _C(S[2]), _C(S[1]), _C(S[0]) );
	printf("C_IN %c ", _C(C_IN) );
	printf("A = %c%c%c%c ", _C(A[3]), _C(A[2]), _C(A[1]), _C(A[0]) );
	printf("B = %c%c%c%c ", _C(B[3]), _C(B[2]), _C(B[1]), _C(B[0]) );
	printf("F = %c%c%c%c ", _C(F[3]), _C(F[2]), _C(F[1]), _C(F[0]) );
	printf("C_OUT %c%c%c%c ", _C(C_OUT),_C(C_OUT3),_C(C_OUT2),_C(C_OUT1));
	printf("OVR %c ", _C(OVR) );
	printf("\n");
}

#define set4(d,v) { d[3] = (v)&8?1:0 ; d[2] = (v)&4?1:0 ; d[1] = (v)&2?1:0 ; d[0] = (v)&1?1:0 ; }
#define set8(d,v) { d[3] = (v)&8?1:0 ; d[2] = (v)&4?1:0 ; d[1] = (v)&2?1:0 ; d[0] = (v)&1?1:0 ; \
 d[7] = (v)&128?1:0 ; d[6] = (v)&64?1:0 ; d[5] = (v)&32?1:0 ; d[4] = (v)&16?1:0 ; \
}


int main(int argc, char *argv[]) {
	set8(S, 0x90);
	set4(S, 0);
	set4(A, 3);
	set4(B, 7);
	M = 1;
	C_IN = 1;
	alu181();
	M = 0;
	C_IN = 1;
	alu181();
	M = 0;
	C_IN = 0;
	alu181();

	set4(S, 1);
	set4(A, 3);
	set4(B, 7);
	M = 1;
	C_IN = 1;
	alu181();
	M = 0;
	C_IN = 1;
	alu181();
	M = 0;
	C_IN = 0;
	alu181();
printf("\n");
	set4(S, 3);
	set4(A, 3);
	set4(B, 7);
	M = 1;
	C_IN = 1;
	alu181();
	M = 0;
	C_IN = 1;
	alu181();
	M = 0;
	C_IN = 0;
	alu181();
printf("\n");
	set4(S, 6);
	set4(A, 3);
	set4(B, 7);
	M = 1;
	C_IN = 1;
	alu181();
	M = 0;
	C_IN = 1;
	alu181();
	M = 0;
	C_IN = 0;
	alu181();
printf("\n");
	set4(S, 9); // Add
	M = 0;
	C_IN = 0;
	set4(A, 3);
	set4(B, 7);
	alu181();
	set4(A, 9);
	set4(B, 6);
	alu181();
	set4(A, 9);
	set4(B, 8);
	alu181();
	set4(A, 7);
	set4(B, 10);
	alu181();
printf("\n");
	set4(S, 6); // Sub
	M = 0;
	C_IN = 1;
	set4(A, 7);
	set4(B, 3);
	alu181();
	set4(A, 3);
	set4(B, 7);
	alu181();
	set4(A, 9);
	set4(B, 1);
	alu181();
	set4(A, 1);
	set4(B, 9);
	alu181();

printf("\n");
}
