`timescale 10ps / 10ps
`define GTK // use VCD

`define MODULE	tb_dac
`ifdef CLK_LIMIT
`else
`define CLK_LIMIT	2000
`endif

module `MODULE;

   reg [23:0] CLK_COUNT;
   reg CLK;   // input
   reg RESET; // input
   reg [7:0] data;
   wire A_OUT;
   wire O_STB;

dac #(.WIDTH(8), .MODE(3)) top
	( .CLK(CLK) 
		, .STB(RESET)
		, .I_DATA(data)
		, .A_OUT(A_OUT)
		, .O_STB(O_STB)
		);

   parameter CLKP = 5000000;        //  50us
   parameter CLKH = CLKP/2;      //
   parameter CLKL = CLKP-CLKH;   //
   
   always begin
      #CLKH CLK = 0;
      #CLKL CLK = 1;
   end

  integer fp;
  initial begin
    fp = $fopen("tb.log");
  end

`ifdef GTK
   initial begin
      $dumpfile("tb.vcd");
      $dumpvars(0,`MODULE.top);
   end
`endif

   initial begin : test
      CLK_COUNT = 0;
      data = 8'b01101011;
      sys_reset();
      while ( (CLK_COUNT < `CLK_LIMIT) )
      begin
         @(posedge CLK);
         CLK_COUNT = CLK_COUNT + 1;
//	 if (WE) $fdisplay(fp, "%02X: %02X", { 2'b00 , O_ADDR }, O_DATA);
      end
//      @(posedge CLK);
      #1
      $display("*** Simulation Complete! ***");
      $finish;
   end

   task sys_reset;
      begin
         #1 RESET = 0;
         @(posedge CLK);
         @(posedge CLK);
         #1 RESET = 1;
         @(posedge CLK);
         @(posedge CLK);
         #1 RESET = 0;
         @(posedge CLK);
         @(posedge CLK);
         CLK_COUNT = CLK_COUNT + 1;
      end
   endtask // sys_reset
   
endmodule // test
