`timescale 10ps / 10ps
`define GTK // use VCD

`define MODULE	tb_mcpu
`ifdef CLK_LIMIT
`else
`define CLK_LIMIT	2000
`endif

module `MODULE;

   reg [23:0] CLK_COUNT;
   reg CLK;   // input
   wire SCL; // inout
   wire SDA; // inout
   reg RESET; // input
   wire [3:0] O;
   wire [5:0] O_ADDR;
   wire [7:0] O_DATA;

mcpu top
	( .CLK(CLK) 
		, .RST(RESET)
		, .WE(WE)
		, .O_ADDR(O_ADDR)
		, .O_DATA(O_DATA)
//		, .SCL(SCL)
//		, .SDA(SDA)
		);

   parameter CLKP = 5000000;        //  50us
   parameter CLKH = CLKP/2;      //
   parameter CLKL = CLKP-CLKH;   //
   
   always begin
      #CLKH CLK = 0;
      #CLKL CLK = 1;
   end

  integer fp;
  initial begin
    fp = $fopen("tb.log");
  end

`ifdef GTK
   initial begin
      $dumpfile("tb.vcd");
      $dumpvars(0,`MODULE.top);
   end
`endif

   initial begin : test
      CLK_COUNT = 0;
      sys_reset();
      while ( (CLK_COUNT < `CLK_LIMIT) )
      begin
         @(posedge CLK);
         CLK_COUNT = CLK_COUNT + 1;
	 if (WE) $fdisplay(fp, "%02X: %02X", { 2'b00 , O_ADDR }, O_DATA);
      end
//      @(posedge CLK);
      #1
      $display("*** Simulation Complete! ***");
      $finish;
   end

   task sys_reset;
      begin
         //PC2 = 0;
         #1 RESET = 1;
         //CLK2X = 0;
         @(posedge CLK);
         @(posedge CLK);
         #1 RESET = 0;
         @(posedge CLK);
         @(posedge CLK);
         CLK_COUNT = CLK_COUNT + 1;
      end
   endtask // sys_reset
   
endmodule // test
